module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	function __export(m) {
	    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
	}
	// export everything as a single module:
	__export(__webpack_require__(1));
	// export entire module as default
	var Async = __webpack_require__(1);
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.default = Async;


/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	function __export(m) {
	    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
	}
	__export(__webpack_require__(2));
	__export(__webpack_require__(3));
	__export(__webpack_require__(4));
	__export(__webpack_require__(5));
	__export(__webpack_require__(7));
	__export(__webpack_require__(6));
	__export(__webpack_require__(8));


/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var Signal_1 = __webpack_require__(3);
	/** Queue of functions to execute when idle (deferred functions) */
	var deferred = [];
	var deferredArgs = [];
	/** True if currently handling deferred functions */
	var runningDeferred = false;
	/** True if already scheduled next handler */
	var scheduled;
	/** Current setTimeout ID, if >= 0 */
	var deferTimeout = -1;
	/** True if postMessage works, too */
	var canPostMessage;
	/** Run a batch of deferred functions */
	function _runDeferred(nonSched) {
	    if (!nonSched)
	        scheduled = false;
	    // run a number of deferred functions
	    runningDeferred = true;
	    var max = Math.max(100, deferred.length >> 2);
	    for (var i = 0; i < deferred.length && i < max; i++) {
	        try {
	            deferred[i].apply(undefined, deferredArgs[i]);
	        }
	        catch (err) {
	            Signal_1.UnhandledException(err);
	        }
	    }
	    runningDeferred = false;
	    // reschedule if necessary
	    if (i < deferred.length) {
	        deferred.splice(0, i);
	        deferredArgs.splice(0, i);
	        if (!scheduled) {
	            scheduled = true;
	            if (canPostMessage)
	                window.postMessage("yield", "*");
	            else
	                deferTimeout = setTimeout(_runDeferred, 0);
	        }
	    }
	    else {
	        deferred.length = 0;
	        deferredArgs.length = 0;
	        if (!canPostMessage) {
	            if (deferTimeout >= 0)
	                clearTimeout(deferTimeout);
	            deferTimeout = -1;
	        }
	    }
	}
	/** Execute given function only when idle, with given arguments (array or `arguments` object) if any */
	function defer(f, args) {
	    deferred.push(f);
	    deferredArgs.push(args);
	    if (!scheduled) {
	        scheduled = true;
	        if (canPostMessage)
	            window.postMessage("yield", "*");
	        else
	            deferTimeout = setTimeout(_runDeferred, 0);
	    }
	}
	exports.defer = defer;
	/** Run a batch of deferred functions; returns true if there are still more deferred functions in the queue (or false to stop infinite recursion if already running) */
	function yieldAll() {
	    if (runningDeferred)
	        return false;
	    _runDeferred(true);
	    return (deferred.length > 0);
	}
	exports.yieldAll = yieldAll;
	// check if postMessage works in this browser and set flag
	if (typeof window === "object") {
	    window.addEventListener("message", function () {
	        canPostMessage = true;
	        _runDeferred();
	    });
	    setTimeout(function () { return window.postMessage("yield", "*"); }, 1);
	}


/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var Defer_1 = __webpack_require__(2);
	var Promise_1 = __webpack_require__(4);
	/** Helper function that generates a handler function which looks for a given method on given target */
	function makeMethodHandler(method, target) {
	    if (!target)
	        throw new TypeError("Target is " + target);
	    return function () {
	        var f = target[method];
	        if (typeof f !== "function")
	            throw new TypeError("Target does not contain method: " + method);
	        f.call(target, arguments);
	    };
	}
	/** A static class for a signal that can be used to trigger one or more handlers asynchronously (use `defineSignal` to create classes) */
	var Signal = (function () {
	    /** Create a signal with given data, ready to be emitted */
	    function Signal(data) {
	        /** @internal */
	        this._emitted = false;
	        this._data = data;
	    }
	    Signal.connect = function (callback, target) {
	        // make handler function if given only a method name
	        if (typeof callback === "string")
	            callback = makeMethodHandler(callback, target);
	        // add handler to the list, return a SignalConnection object
	        var connection = { disconnected: false };
	        connection.disconnect = Signal._connect.call(this, callback, connection);
	        return connection;
	    };
	    Signal.connectOnce = function (callback, target) {
	        // make handler function if given only a method name
	        if (typeof callback === "string")
	            callback = makeMethodHandler(callback, target);
	        // add wrapper to the list, call handler only once
	        var called = false, un = Signal._connect.call(this, function (data, src) {
	            if (!called) {
	                called = true;
	                un();
	                callback(data, src);
	            }
	        });
	    };
	    /** @internal Implementation of connect: returns disconnect function [used to speed up connections in other Async classes] */
	    Signal._connect = function (callback, signalConnection) {
	        var _this = this;
	        // add handler to the list
	        switch (this._nHandlers++) {
	            case 0:
	                // call "up" listener to make sure signals get emitted
	                this._handler1 = callback;
	                this.onHandlerConnected && this.onHandlerConnected();
	                break;
	            case 1:
	                this._handler2 = callback;
	                break;
	            default:
	                (this._handlers || (this._handlers = []))
	                    .push(callback);
	        }
	        return function () {
	            // remove handler from the list
	            switch (_this._nHandlers) {
	                case 0: return;
	                case 1:
	                    if (_this._handler1 === callback)
	                        _this._handler1 = undefined, _this._nHandlers--;
	                    break;
	                case 2:
	                    if (_this._handler1 === callback)
	                        _this._handler1 = _this._handler2,
	                            _this._handler2 = undefined, _this._nHandlers--;
	                    else if (_this._handler2 === callback)
	                        _this._handler2 = undefined, _this._nHandlers--;
	                    break;
	                default:
	                    if (_this._handler1 === callback)
	                        _this._handler1 = _this._handler2,
	                            _this._handler2 = _this._handlers.shift(),
	                            _this._nHandlers--;
	                    else if (_this._handler2 === callback)
	                        _this._handler2 = _this._handlers.shift(),
	                            _this._nHandlers--;
	                    else
	                        for (var i = 0; i < _this._nHandlers; i++) {
	                            if (_this._handlers[i] === callback) {
	                                _this._handlers.splice(i, 1);
	                                _this._nHandlers--;
	                                break;
	                            }
	                        }
	            }
	            // check new length: call "down" listener if none
	            if (!_this._nHandlers && _this.onHandlersDisconnected)
	                _this.onHandlersDisconnected();
	            // set disconnected flag
	            if (signalConnection)
	                signalConnection.disconnected = true;
	        };
	    };
	    /** Remove all handlers; returns this */
	    Signal.disconnectAll = function () {
	        // call "down" callback to allow signals to stop for now
	        if (this._nHandlers) {
	            this._handler1 = undefined;
	            this._handler2 = undefined;
	            delete this._handlers;
	            this._nHandlers = 0;
	            this.onHandlersDisconnected && this.onHandlersDisconnected();
	        }
	        return this;
	    };
	    /** Returns true if this signal has any handlers */
	    Signal.isConnected = function () {
	        return (this._nHandlers > 0);
	    };
	    /** @internal Invoke all handlers synchronously, without creating a Signal instance at all; exceptions in handlers are NOT caught here */
	    Signal.emitSync = function (data) {
	        if (this._nHandlers) {
	            if (this._handler1)
	                this._handler1.call(undefined, data, this);
	            if (this._handler2)
	                this._handler2.call(undefined, data, this);
	            var handlers = this._handlers;
	            if (handlers) {
	                for (var i = 0, len = handlers.length; i < len; i++)
	                    handlers[i] && handlers[i].call(undefined, data, this);
	            }
	        }
	    };
	    /** @internal Invoke all handlers synchronously, without creating a Signal instance at all; exceptions in handlers are NOT caught here */
	    Signal.emit = function (data) {
	        if (this._nHandlers) {
	            var args = [data, this];
	            if (this._handler1)
	                Defer_1.defer(this._handler1, args);
	            if (this._handler2)
	                Defer_1.defer(this._handler2, args);
	            var handlers = this._handlers;
	            if (handlers) {
	                for (var i = 0, len = handlers.length; i < len; i++)
	                    handlers[i] && Defer_1.defer(handlers[i], args);
	            }
	        }
	    };
	    /** Invoke all handlers and capture promises of their return values in .results (unless argument is true); works only once; returns this */
	    Signal.prototype.emit = function (noResults) {
	        if (this._emitted)
	            return this;
	        this._emitted = true;
	        var nHandlers = this.constructor._nHandlers;
	        if (!nHandlers)
	            return this;
	        var handler1 = this.constructor._handler1;
	        var handler2 = this.constructor._handler2;
	        var handlers = this.constructor._handlers;
	        var args = [this._data, this.constructor];
	        if (!noResults) {
	            // intialize an array of Promises
	            var results = this._results = [handler1 ?
	                    Promise_1.Promise.defer(handler1, args) :
	                    Promise_1.Promise.resolve(undefined)];
	            if (nHandlers > 1)
	                results.push(handler2 ?
	                    Promise_1.Promise.defer(handler2, args) :
	                    Promise_1.Promise.resolve(undefined));
	            if (nHandlers > 2)
	                handlers.forEach(function (f) { return results.push(f ?
	                    Promise_1.Promise.defer(f, args) :
	                    Promise_1.Promise.resolve(undefined)); });
	        }
	        else {
	            // no need to capture results, schedule plain handlers
	            Defer_1.defer(handler1, args);
	            if (nHandlers > 1)
	                Defer_1.defer(handler2, args);
	            if (nHandlers > 2)
	                handlers.forEach(function (f) { return f && Defer_1.defer(f, args); });
	        }
	        if (this._onEmit)
	            this._onEmit(true);
	        return this;
	    };
	    /** Invoke given callback(s) with return values of all handlers, or any exception that occurred during execution of all handlers; returns a Promise that resolves to the return value of the callback(s) itself */
	    Signal.prototype.then = function (onFulfilled, onRejected) {
	        var _this = this;
	        if (!this._promise) {
	            if (!this._emitted)
	                this._promise = new Promise_1.Promise(function (r) { _this._onEmit = r; })
	                    .then(function () { return Promise_1.Promise.all(_this.results); });
	            else
	                this._promise = Promise_1.Promise.all(this.results);
	        }
	        return this._promise.then(onFulfilled, onRejected);
	    };
	    /** Catch errors that occur during execution of all handlers; returns a Promise that resolves to the return value of the callback itself */
	    Signal.prototype.catch = function (onRejected) {
	        return this.then(undefined, onRejected);
	    };
	    Object.defineProperty(Signal.prototype, "results", {
	        /** Array of Promises that resolve to return values of all handlers */
	        get: function () {
	            return this._results || [];
	        },
	        enumerable: true,
	        configurable: true
	    });
	    return Signal;
	}());
	/** @internal Number of handlers */
	Signal._nHandlers = 0;
	exports.Signal = Signal;
	function defineSignal(Base, props) {
	    if (Base === void 0) { Base = Signal; }
	    var Result = function Signal(_token) {
	        if (!(this instanceof Result)) {
	            // called as a function, not a constructor: emit directly
	            Result.emit.apply(Result, arguments);
	        }
	        else {
	            // called as a constructor, just call base constructor
	            Base.apply(this, arguments);
	        }
	    };
	    // copy static methods/members and apply prototype
	    _object_assign(Result, Base);
	    _object_assign(Result, props);
	    Result.prototype = Object.create(Base.prototype);
	    Result.prototype.constructor = Result;
	    // clear all handlers for this class object and return the class
	    Result._nHandlers = 0;
	    return Result;
	}
	exports.defineSignal = defineSignal;
	// Simple polyfill for Object.assign
	var _object_assign = Object.assign;
	if (!_object_assign) {
	    _object_assign = function (target, source) {
	        if (source) {
	            for (var id in source) {
	                if (Object.prototype.hasOwnProperty.call(source, id))
	                    target[id] = source[id];
	            }
	        }
	        return target;
	    };
	}
	/** Signal that is triggered with exceptions that were unhandled during async execution; a custom handler may be added here, the default handler just writes a warning message to the console; to disable this behavior for specific errors, set error.message to a blank string */
	exports.UnhandledException = defineSignal();
	// hook up default behavior:
	exports.UnhandledException._connect(function (error) {
	    try {
	        error && error.message && console && (console.warn || console.log)("Unhandled exception in asynchronous code - ", error);
	    }
	    catch (all) { }
	});


/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var Defer_1 = __webpack_require__(2);
	var Signal_1 = __webpack_require__(3);
	/** Represents a value to be resolved at any time in the future */
	var Promise = (function () {
	    /** Create a new Promise instance by running the given callback function, which is given callbacks to resolve and/or reject the promise; the promise is also rejected if the callback function throws an exception */
	    function Promise(executor) {
	        /* @internal */
	        this._Resolve = Signal_1.defineSignal();
	        /* @internal */
	        this._Reject = Signal_1.defineSignal();
	        if (typeof executor === "function")
	            this._resolveWith(executor);
	    }
	    /** Delay the execution of a callback but return a promise for its result */
	    Promise.delay = function (f, ms, args) {
	        var result = new Promise();
	        // set a timer and run all deferred functions right away (e.g. .then(...))
	        setTimeout(function () {
	            result._resolveWith(function (r) { return r(f.apply(undefined, args)); });
	            Defer_1.yieldAll();
	        }, ms);
	        return result;
	    };
	    /** Return a promise that will be resolved after a delay */
	    Promise.sleep = function (ms, value) {
	        return Promise.delay(function () { return value; }, ms);
	    };
	    /** Defer the execution of a callback but return a promise for its result */
	    Promise.defer = function (f, args) {
	        var result = new Promise();
	        Defer_1.defer(function () { result._resolveWith(function (r) { return r(f.apply(undefined, args)); }); });
	        return result;
	    };
	    /** Executes given callback, providing it with a Node.js-style (err, result) => {...} handler that immediately resolves or rejects the resulting promise when called; (use as e.g. `Promise.fn(f => fs.readFile('/etc/passwd', f)).then(...))` */
	    Promise.fn = function (callback) {
	        return new Promise(function (resolve, reject) {
	            callback(function (err, result) {
	                if (err)
	                    reject(err);
	                else
	                    resolve(result);
	            });
	        });
	    };
	    /** Return a resolved promise */
	    Promise.resolve = function (value) {
	        return new Promise()._resolve(value);
	    };
	    /** Return a rejected promise */
	    Promise.reject = function (error) {
	        return new Promise()._reject(error);
	    };
	    /** Return a promise that is fulfilled when all given promises are fulfilled and is immediately rejected when one of the promises is rejected */
	    Promise.all = function (promises) {
	        var result = new Promise();
	        var values = [];
	        var left = promises.length;
	        // fulfill promise if not rejected before
	        function fulfill() {
	            !result._isRejected && result._resolve(values);
	        }
	        // wait for each given promise
	        promises.forEach(function (p, i) {
	            p.then(function (value) {
	                values[i] = value;
	                --left || fulfill();
	            }, function (error) {
	                result._reject(error);
	            });
	        });
	        // fulfill already if no promises given
	        !left && fulfill();
	        return result;
	    };
	    /** Return a promise that is resolved or rejected exactly like the first of the given promises that is resolved or rejected */
	    Promise.race = function (promises) {
	        var result = new Promise();
	        promises.forEach(function (p) {
	            p.then(function (value) { return result._resolve(value); }, function (error) { return result._reject(error); });
	        });
	        return result;
	    };
	    /** Run one of the callbacks as soon as the promise is fulfilled or rejected */
	    Promise.prototype.then = function (onFulfilled, onRejected) {
	        var _this = this;
	        var result = new Promise();
	        if (this._isResolved) {
	            // if already fulfilled, schedule call to onFulfilled or fulfill now
	            if (typeof onFulfilled === "function")
	                Defer_1.defer(function () { result._resolveWith(function (r) { return r(onFulfilled(_this._value)); }); });
	            else
	                result._resolve(this._value);
	        }
	        else if (this._isRejected) {
	            // if already rejected, schedule call to onRejected or reject now
	            if (typeof onRejected === "function")
	                Defer_1.defer(function () { result._resolveWith(function (r) { return r(onRejected(_this._error)); }); });
	            else
	                result._reject(this._error);
	            // set flag to make sure UnhandledException does not get called async
	            this._hndRejection = true;
	        }
	        else {
	            // fulfill result when ready
	            if (typeof onFulfilled === "function") {
	                this._Resolve._connect(function (v) {
	                    return result._resolveWith(function (r) { return r(onFulfilled(v)); });
	                });
	            }
	            else {
	                // pass on result if no handler passed in
	                this._Resolve._connect(function (v) { return result._resolve(v); });
	            }
	            // handle rejections
	            if (typeof onRejected === "function") {
	                this._Reject._connect(function (v) {
	                    return result._resolveWith(function (r) { return r(onRejected(v)); });
	                });
	            }
	            else {
	                // pass on rejections if no handler passed in
	                this._Reject._connect(function (v) { return result._reject(v); });
	            }
	        }
	        // always return a promise with the result of onFulfilled OR onRejected
	        return result;
	    };
	    /** Alternative method to catch rejections */
	    Promise.prototype.catch = function (onRejected) {
	        return this.then(undefined, onRejected);
	    };
	    /** @internal Return current status: null if unfulfilled, object with value property (if resolved), and/or error property (if rejected) */
	    Promise.prototype._getStatus = function () {
	        if (this._isResolved)
	            return { value: this._value };
	        if (this._isRejected)
	            return { rejected: true, error: this._error };
	        return null;
	    };
	    /** @internal Resolve the promise with a value, or (future) result of a promise */
	    Promise.prototype._resolve = function (value, resolving) {
	        var _this = this;
	        if (!this._isResolved && !this._isRejected &&
	            (!this._resolving || resolving === this._resolving)) {
	            if (value === this)
	                throw new TypeError("Recursive promise found");
	            try {
	                var thenFn = value && value.then;
	                if (typeof thenFn === "function" &&
	                    ((typeof value === "object") || (typeof value === "function"))) {
	                    // wait for promise to be resolved and recurse
	                    resolving = this._resolving = {};
	                    thenFn.call(value, function (v) { _this._resolve(v, resolving); }, function (e) { _this._reject(e, resolving); });
	                }
	                else {
	                    // set status and schedule handler chain (if any)
	                    this._isResolved = true;
	                    this._resolving = null;
	                    this._value = value;
	                    this._Resolve.emit(value);
	                }
	            }
	            catch (e) {
	                // oops, caught an exception, now reject this promise
	                this._reject(e, resolving);
	            }
	        }
	        return this;
	    };
	    /** @internal Run a function that may resolve or reject the promise */
	    Promise.prototype._resolveWith = function (executor) {
	        var _this = this;
	        try {
	            // call resolver function with callback for resolving this promise
	            executor(function (v) { _this._resolve(v); }, function (e) { _this._reject(e); });
	        }
	        catch (e) {
	            // oops, caught an exception, now reject this promise
	            this._reject(e);
	        }
	        return this;
	    };
	    /** @internal Reject the promise because an error occurred */
	    Promise.prototype._reject = function (error, resolving) {
	        var _this = this;
	        // set status and schedule handler chain (if any)
	        if (!this._isResolved && !this._isRejected &&
	            (!this._resolving || resolving === this._resolving)) {
	            this._isRejected = true;
	            this._error = error;
	            if (this._Reject.isConnected()) {
	                // emit signal which is handled by onRejected handler(s)
	                this._Reject.emit(error);
	            }
	            else {
	                // emit signal async if still not handled
	                // (wait for chained calls on already-rejected promise)
	                Defer_1.defer(function () {
	                    _this._hndRejection ||
	                        Signal_1.UnhandledException.emit(error);
	                });
	            }
	        }
	        return this;
	    };
	    return Promise;
	}());
	exports.Promise = Promise;
	/** Return a promise that will be resolved after a delay */
	function sleep(ms, value) {
	    return Promise.delay(function () { return value; }, ms);
	}
	exports.sleep = sleep;


/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || function (d, b) {
	    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
	    function __() { this.constructor = d; }
	    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	};
	var Defer_1 = __webpack_require__(2);
	var Promise_1 = __webpack_require__(4);
	var Signal_1 = __webpack_require__(3);
	var ObservableObject_1 = __webpack_require__(6);
	var ObservableArray_1 = __webpack_require__(7);
	/** Watched observable currently evaluating, if any; used to connect dependencies through signals */
	var currentWatchedEvaling = null;
	/** Unwatched observable currently evaluating, if any; used to collect dependencies for dirty checking */
	var currentUnwatchedEvaling = null;
	/** @internal Throws an error if currently running wached observable getter */
	function assertUnobserved() {
	    if (currentWatchedEvaling || currentUnwatchedEvaling)
	        throw new Error("Observable getter must be a pure function, " +
	            "cannot create or set other observables");
	}
	exports.assertUnobserved = assertUnobserved;
	/** Represents an observable value (with the value itself in `.value`) */
	var ObservableValue = (function () {
	    /** Create a new (single) observed value using optional getter and setter functions; note that getters *should* be pure functions without side effects, creating or setting other observables from the getter will result in an error; getter is not called immediately but only when being subscribed to or when obtaining the value itself (from `.value`) */
	    function ObservableValue(getter, setter) {
	        /** @internal Unique ID used to quickly index dependants of observables */
	        this._uid = String(++ObservableValue.UID);
	        /** @internal Counter that is incremented every time the value becomes unstable (i.e. value set directly, dependency changed, etc.) */
	        this._dirtyIdx = 0;
	        assertUnobserved();
	        // hold off on evaluating until value getter is called
	        if (getter) {
	            this._getter = getter;
	            this._dirtyIdx++;
	        }
	        this._setter = setter;
	    }
	    /** Encapsulate given value as an ObservableValue */
	    ObservableValue.fromValue = function (value) {
	        var result = new ObservableValue();
	        result.value = value;
	        return result;
	    };
	    /** Encapsulate given promised value as an ObservableValue; the observed value will start out as `undefined` but then changes to the `Promise` result when resolved; or if promise was rejected, hangs on to the error and throws it when retrieving the observable value */
	    ObservableValue.fromPromise = function (valuePromise) {
	        var result = new ObservableValue();
	        if (valuePromise instanceof Promise_1.Promise) {
	            // shortcut promise status to avoid async
	            var status = valuePromise._getStatus();
	            if (status) {
	                if (status.rejected) {
	                    // set value to "error" to trigger change signal
	                    result.value = "error";
	                    result._error = status.error;
	                    result._ro = true;
	                    return result;
	                }
	                else {
	                    // set value to resolved promise value
	                    result.value = status.value;
	                    result._ro = true;
	                    return result;
	                }
	            }
	        }
	        valuePromise.then(function (value) {
	            // set value to resolved promise value
	            result.value = value;
	            result._ro = true;
	        }, function (error) {
	            // set value to "error" to trigger change signal
	            result.value = "error";
	            result._error = error;
	            result._ro = true;
	        });
	        return result;
	    };
	    /** Set a getter function for the observable value, which should return a current value, or another ObservableValue instance, or set `.value` directly; note that getters *should* be pure functions without side effects, creating or setting other observables from the getter will result in an error; the getter is only invoked (asynchronously) if a value had been set previously and needs to be updated; reading `.value` from the getter results in the value previously set, no recursion occurs; returns this */
	    ObservableValue.prototype.getter = function (f) {
	        assertUnobserved();
	        this._getter = f;
	        // remove current static value and re-eval if needed
	        if (Object.prototype.hasOwnProperty.call(this, "_val")) {
	            if (f)
	                delete this._val;
	            this._asyncEval();
	        }
	        return this;
	    };
	    /** Set a setter function for the observable value; setting `.value` directly from the setter results in changing the underlying observable value (which can also be read by the getter, or the setter itself), no recursion occurs; returns this */
	    ObservableValue.prototype.setter = function (f) {
	        assertUnobserved();
	        this._setter = f;
	        return this;
	    };
	    Object.defineProperty(ObservableValue.prototype, "value", {
	        /** Observable value, (re-) evaluated only if necessary; when set to an `ObservableValue` instance, this property returns that instance's value, until this property is set to another value (except if the `ObservableValue` has a setter, which is called first); plain Array values are turned into `ObservableArray` instances, and plain Object instances into `ObservableObject` instances */
	        get: function () {
	            if (this._error)
	                throw this._error;
	            if (this._getting)
	                return this._val;
	            if (!this._setting && !this._ro) {
	                // register as dependency to previously evaluating observable
	                if (currentWatchedEvaling)
	                    currentWatchedEvaling._addConnection(this);
	                else if (currentUnwatchedEvaling)
	                    currentUnwatchedEvaling._addCheck(this);
	                // re-evaluate if necessary:
	                if (this._needsEval()) {
	                    this._oldConnections = this._depConnections;
	                    var hasValue = this.hasOwnProperty("_val");
	                    var oldValue = this._val;
	                    // set this instance as currently evaluating to find dependencies
	                    var prevWatched = currentWatchedEvaling, prevUnwatched = currentUnwatchedEvaling;
	                    if (this._watched) {
	                        currentWatchedEvaling = this;
	                        this._depConnections = {};
	                    }
	                    else {
	                        currentUnwatchedEvaling = this;
	                        this._depChecks = [];
	                    }
	                    this._getting = true;
	                    this._direct = false;
	                    try {
	                        // store getter result or let getter set value directly
	                        var result = this._getter.call(undefined);
	                        if (!(result === undefined && this._direct))
	                            this._val = result;
	                    }
	                    finally {
	                        this._getting = false;
	                        // stop solliciting dependencies
	                        currentWatchedEvaling = prevWatched;
	                        currentUnwatchedEvaling = prevUnwatched;
	                    }
	                    // mark value as up to date
	                    this._valIdx = this._dirtyIdx;
	                    // unsubscribe from old dependencies that are no longer used
	                    var oldConnections = this._oldConnections;
	                    delete this._oldConnections;
	                    if (this._depConnections) {
	                        for (var uid in oldConnections)
	                            if (!this._depConnections[uid])
	                                oldConnections[uid].dis();
	                    }
	                    // emit signal(s) if changed
	                    if (hasValue && this._val !== oldValue) {
	                        this._auxSignalers && this._auxSignalers.forEach(function (f) { return f(); });
	                        this._Signal && this._Signal.emitSync(this._val);
	                    }
	                }
	            }
	            // return new value or proxy other ObservableValue's value
	            var value = this._val;
	            while (value instanceof ObservableValue)
	                value = value.value;
	            return value;
	        },
	        set: function (value) {
	            if (!this._getting && !this._setting)
	                assertUnobserved();
	            // convert plain arrays and objects (unless about to run setter)
	            if (!this._setter || this._setting) {
	                // make ObservableArray instances out of plain Arrays
	                if (value instanceof Array && value.constructor === Array) {
	                    value = ObservableArray_1.ObservableArray.fromArray(value);
	                }
	                // make ObservableObject instances out of plain Objects
	                if (value instanceof Object && value.constructor === Object) {
	                    value = new ObservableObject_1.ObservableObject(value);
	                }
	            }
	            // check what to do with the new value:
	            if (this._getting) {
	                // set value directly, no signals but mark as changed
	                this._val = value;
	                this._direct = true;
	                this._valIdx = ++this._dirtyIdx;
	            }
	            else if (this._getter && !this._setter || this._ro) {
	                // cannot set value directly outside of getter function
	                // (or value is resolved Promise)
	                throw new Error("Cannot set value");
	            }
	            else if ((!this._setter || this._setting) &&
	                (this._val instanceof ObservableValue) &&
	                this._val._setter) {
	                // proxy through observable value setter
	                this._val.value = value;
	            }
	            else if (this._setter && !this._setting) {
	                // invoke setter
	                this._setting = true;
	                try {
	                    this._setter.call(undefined, value);
	                }
	                finally {
	                    this._setting = false;
	                }
	            }
	            else if (value !== this._val) {
	                // mark value as changed (but not dirty)
	                this._valIdx = ++this._dirtyIdx;
	                // set value and emit signal(s)
	                this._val = value;
	                this._auxSignalers && this._auxSignalers.forEach(function (f) { return f(); });
	                this._Signal && this._Signal.emitSync(value);
	            }
	        },
	        enumerable: true,
	        configurable: true
	    });
	    /** Returns .value (observable if used within an observable getter) */
	    ObservableValue.prototype.valueOf = function () { return this.value; };
	    /** Returns .value as a string (observable if used within an observable getter) */
	    ObservableValue.prototype.toString = function () { return String(this.value); };
	    /** Returns last value set, does not re-evaluate and/or add dependency */
	    ObservableValue.prototype.getLastValue = function () {
	        // return value or proxy other ObservableValue's value
	        var value = this._val;
	        while (value instanceof ObservableValue)
	            value = value.getLastValue();
	        return value;
	    };
	    /** Transform this observable value using given function, into a new ObservableValue instance; note that the transformation function is not necessarily invoked after each value change, if the new observable is not subscribed to and/or multiple changes occur (asynchronously) before the transformation is evaluated; observables used by the given function itself are not automatically subscribed to (wrap given function in observe(...) to observe dependencies as well) */
	    ObservableValue.prototype.map = function (callback) {
	        var _this = this;
	        var lastValue = {};
	        var mapped = new ObservableValue(function () {
	            var value = _this.value;
	            if (value === lastValue)
	                return mapped.value;
	            return unobserved(callback, lastValue = value);
	        });
	        return mapped;
	    };
	    ObservableValue.prototype.subscribe = function (callback) {
	        var _this = this;
	        (this._Signal || this._sig())._connect(callback);
	        // listen for signal emissions while initializing value if needed
	        var current = this._val, emitted = false, f;
	        if (this._getter || this._val instanceof ObservableValue) {
	            if (!this._auxSignalers)
	                this._auxSignalers = [];
	            this._auxSignalers.push(f = function () { emitted = true; });
	            unobserved(function () { current = _this.value; });
	            if (this._auxSignalers.length === 1)
	                delete this._auxSignalers;
	            else
	                this._auxSignalers = this._auxSignalers.filter(function (v) { return v !== f; });
	        }
	        // if not already emitted signal, invoke callback for current value
	        if (!emitted)
	            callback && Defer_1.defer(callback, [current]);
	        return this;
	    };
	    /** Start listening for changes to this observable value and all of its dependencies asynchronously, and return a promise for the next (different) value of the observable; stops subscribing immediately after the promise is resolved */
	    ObservableValue.prototype.next = function () {
	        var _this = this;
	        var result = new Promise_1.Promise(function (resolve) {
	            (_this._Signal || _this._sig()).connectOnce(function (v) { resolve(v); });
	        });
	        // initialize value if needed
	        if (this._getter || this._val instanceof ObservableValue)
	            unobserved(function () { _this.value; });
	        return result;
	    };
	    Object.defineProperty(ObservableValue.prototype, "subscribed", {
	        /** True if this observable value is currently subscribed to, either directly or from dependent observables */
	        get: function () { return this._watched; },
	        enumerable: true,
	        configurable: true
	    });
	    Object.defineProperty(ObservableValue.prototype, "writable", {
	        /** True if this observable value is writable (not only a getter defined) */
	        get: function () { return !this._getter || !!this._setter; },
	        enumerable: true,
	        configurable: true
	    });
	    /** @internal Add a signal to emit when this value changes, but do not watch for changes directly (i.e. does not connect to signal and start watching); used e.g. to emit Observable.PropertyChange */
	    ObservableValue.prototype.emitOnChange = function (signal, data) {
	        if (!this._auxSignalers)
	            this._auxSignalers = [];
	        this._auxSignalers.push(function () { signal(data); });
	    };
	    /** Clear value and remove getter/setter functions, unsubscribe from dependencies */
	    ObservableValue.prototype.clear = function () {
	        this.getter(null).setter(null);
	    };
	    /** @internal Returns true if value needs to be reevaluated */
	    ObservableValue.prototype._needsEval = function () {
	        if (!this._getter)
	            return false;
	        if ((this._valIdx || 0) !== this._dirtyIdx)
	            return true;
	        // if value is watched, then dependencies are watched too
	        // and are up to date if value is up to date (above check)
	        if (this._watched)
	            return false;
	        // check if dependencies (may) have changed since last evaluation
	        return !this._depChecks || this._depChecks.some(function (f) { return f({}); });
	    };
	    /** @internal Mark as dirty (if not already dirty) and schedule re-evaluation of value if still watched */
	    ObservableValue.prototype._asyncEval = function () {
	        var _this = this;
	        if ((this._valIdx || 0) === this._dirtyIdx && !this._getting) {
	            this._dirtyIdx++;
	            Defer_1.defer(function () {
	                if (_this._watched && _this._valIdx !== _this._dirtyIdx)
	                    _this.value;
	            });
	        }
	    };
	    /** @internal Register a watched dependency of this value */
	    ObservableValue.prototype._addConnection = function (other) {
	        if (other === this)
	            return;
	        if (!this._depConnections)
	            this._depConnections = {};
	        // check if connection already existed
	        var old;
	        if (this._oldConnections && (old = this._oldConnections[other._uid])) {
	            // use existing object
	            this._depConnections[other._uid] = old;
	        }
	        else {
	            // add handler to mark this value as dirty whenever other value
	            // changes (not async since signal is always emitted synchronously,
	            // see above); _connect returns disconnect method
	            var dis = (other._Signal || other._sig())._connect(this._asyncEval.bind(this));
	            // store new dependency object
	            this._depConnections[other._uid] = { dep: other, dis: dis };
	        }
	    };
	    /** @internal Register an unwatched dependency of this value (checked for changes every time when getting the unwatched observable value) */
	    ObservableValue.prototype._addCheck = function (other) {
	        var _this = this;
	        if (other === this)
	            return;
	        // maintain a function to check if the other value has changed
	        // (different _dirtyIdx or recurse down dependency tree)
	        var lastDirtyIdx = other._dirtyIdx;
	        (this._depChecks || (this._depChecks = [])).push(function (seen) {
	            if (seen[_this._uid])
	                return true;
	            seen[_this._uid] = true;
	            return (other._dirtyIdx !== lastDirtyIdx ||
	                !other._depChecks || other._depChecks.some(function (f) { return f(seen); }));
	        });
	    };
	    /** @internal Disconnect existing dependencies */
	    ObservableValue.prototype._removeDependencies = function () {
	        delete this._depChecks;
	        var connections = this._depConnections;
	        delete this._depConnections;
	        for (var uid in connections)
	            connections[uid].dis();
	    };
	    /** @internal Instantiate and return the value change signal */
	    ObservableValue.prototype._sig = function () {
	        return (this._Signal = Signal_1.defineSignal(ObservableValue.ValueChangeSignal, { ref: this }));
	    };
	    return ObservableValue;
	}());
	ObservableValue.UID = 0;
	/** @internal Signal class with initializer */
	ObservableValue.ValueChangeSignal = (function (_super) {
	    __extends(class_1, _super);
	    function class_1() {
	        return _super.apply(this, arguments) || this;
	    }
	    /** Called when a first handler is connected */
	    class_1.onHandlerConnected = function () {
	        var ref = this.ref;
	        ref._watched = true;
	        if (!ref._depChecks || ref._depChecks.length) {
	            // not sure about dependencies, force re-eval
	            ref._removeDependencies();
	            ref._dirtyIdx++;
	        }
	        else {
	            // no dependencies last time, no need to check
	            ref._removeDependencies();
	        }
	    };
	    /** Called when all handlers have been disconnected */
	    class_1.onHandlersDisconnected = function () {
	        // all handlers have been disconnected:
	        this.ref._watched = false;
	        this.ref._removeDependencies();
	    };
	    return class_1;
	}(Signal_1.Signal));
	exports.ObservableValue = ObservableValue;
	function observe(v) {
	    return (typeof v === "function") ? new ObservableValue(v) :
	        (v && typeof v === "object" && typeof v.then === "function") ?
	            ObservableValue.fromPromise(v) :
	            (v instanceof Array) ?
	                ObservableArray_1.ObservableArray.fromArray(v) :
	                (v instanceof Object) ?
	                    new ObservableObject_1.ObservableObject(v) :
	                    (function () { throw new TypeError(); })();
	}
	exports.observe = observe;
	function unobserved(f) {
	    var prevWatched = currentWatchedEvaling;
	    var prevUnwatched = currentUnwatchedEvaling;
	    try {
	        currentWatchedEvaling = null;
	        currentUnwatchedEvaling = null;
	        return f.apply(undefined, Array.prototype.slice.call(arguments, 1));
	    }
	    finally {
	        currentWatchedEvaling = prevWatched;
	        currentUnwatchedEvaling = prevUnwatched;
	    }
	}
	exports.unobserved = unobserved;


/***/ },
/* 6 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || function (d, b) {
	    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
	    function __() { this.constructor = d; }
	    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	};
	var Signal_1 = __webpack_require__(3);
	var Observable_1 = __webpack_require__(5);
	/** Represents an object with observable members (use the constructor's argument to specify which members are observable and their initial values); may be extended into a derived class, but can be used as new Observable({...}) as well, OR use static .mixin(object) to mix into any object [requires ES5+ target] */
	var ObservableObject = (function () {
	    /** Create an object with (some) observable members, copying initial values from given object; `ObservableValue` instances are referenced directly (including getter and setter), Array properties are turned into `ObservableArray` instances, and plain Object instances into `ObservableObject` instances; also seals the new instance if the object parameter was sealed, and freezes it if the object parameter was frozen */
	    function ObservableObject(obj) {
	        Observable_1.assertUnobserved();
	        if (obj instanceof Object) {
	            // copy properties and status
	            ObservableObject.makeObservable(this, obj);
	            _addSignalGetter(this);
	            if (Object.isFrozen(obj)) {
	                // go through all properties to initialize hidden observable first
	                for (var member in obj)
	                    this[member];
	                Object.freeze(this);
	            }
	            else if (Object.isSealed(obj)) {
	                // go through all properties to initialize hidden observable first
	                for (var member in obj)
	                    this[member];
	                Object.seal(this);
	            }
	        }
	        else {
	            // just initialize this instance as a new object
	            _addSignalGetter(this);
	        }
	    }
	    /** Returns a new ObservableObject with properties copied from given object; (same as constructor but with typed return value) */
	    ObservableObject.fromObject = function (obj) {
	        return new ObservableObject(obj);
	    };
	    /** Mix in ObservableObject method and signal, and make all enumerable properties of given object observable */
	    ObservableObject.mixin = function (obj) {
	        return ObservableObject.makeObservable(obj, obj);
	    };
	    /** Returns true if property with given name is observable */
	    ObservableObject.prototype.hasObservableProperty = function (name) {
	        return ObservableObject.isObservableProperty(this, name);
	    };
	    return ObservableObject;
	}());
	exports.ObservableObject = ObservableObject;
	(function (ObservableObject) {
	    /** Base class for signals that are emitted when any observed property is modified on an ObservableObject instance, with the name of the property as a parameter */
	    var PropertyChangeSignal = (function (_super) {
	        __extends(PropertyChangeSignal, _super);
	        function PropertyChangeSignal() {
	            return _super.apply(this, arguments) || this;
	        }
	        return PropertyChangeSignal;
	    }(Signal_1.Signal));
	    ObservableObject.PropertyChangeSignal = PropertyChangeSignal;
	})(ObservableObject = exports.ObservableObject || (exports.ObservableObject = {}));
	exports.ObservableObject = ObservableObject;
	(function (ObservableObject) {
	    function makeObservable(obj, spec) {
	        if (typeof spec === "string" || typeof spec === "number") {
	            // add getter and setter for single property value
	            var propertyName = String(spec);
	            var desc = Object.getOwnPropertyDescriptor(obj, propertyName);
	            _defineObservableProperty(obj, propertyName, desc.value, desc.get, desc.set);
	        }
	        else {
	            // define several non-configurable properties with getters and setters
	            var specIsObservable = (spec instanceof ObservableObject);
	            var desc;
	            for (var member in spec) {
	                if ((specIsObservable ?
	                    spec.hasObservableProperty(member) :
	                    Object.prototype.hasOwnProperty.call(spec, member)) &&
	                    (desc = Object.getOwnPropertyDescriptor(spec, member))) {
	                    _defineObservableProperty(obj, member, desc.value, desc.get, desc.set);
	                }
	            }
	            // add mixins
	            Object.defineProperty(obj, "hasObservableProperty", {
	                configurable: false,
	                writable: false,
	                enumerable: false,
	                value: ObservableObject.prototype.hasObservableProperty
	            });
	            _addSignalGetter(obj);
	        }
	        return obj;
	    }
	    ObservableObject.makeObservable = makeObservable;
	    /** Delete the property with given name and clear its observable value */
	    function deleteObservableProperty(obj, member) {
	        var hiddenMember = _getHiddenName(member);
	        var observable = obj[hiddenMember];
	        if (observable && observable.subscribed && observable.writable)
	            observable.value = undefined;
	        delete obj[member];
	        delete obj[hiddenMember];
	    }
	    ObservableObject.deleteObservableProperty = deleteObservableProperty;
	    /** Returns true if property with given name is observable */
	    function isObservableProperty(obj, member) {
	        var hiddenMember = _getHiddenName(member);
	        if (Object.prototype.hasOwnProperty.call(obj, hiddenMember))
	            return true;
	        var ppDescriptor = _getProtoPropDesc(obj, member);
	        if (ppDescriptor && ppDescriptor.get && ppDescriptor.get["*observable-getter"])
	            return true;
	        return false;
	    }
	    ObservableObject.isObservableProperty = isObservableProperty;
	})(ObservableObject = exports.ObservableObject || (exports.ObservableObject = {}));
	exports.ObservableObject = ObservableObject;
	// =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
	/** Helper function to add a getter for the `ObservableObject.PropertyChange` signal to any object */
	function _addSignalGetter(obj) {
	    if (!Object.prototype.hasOwnProperty.call(obj, "PropertyChange")) {
	        var Signal;
	        Object.defineProperty(obj, "PropertyChange", {
	            configurable: false,
	            enumerable: false,
	            get: function () { return (Signal || (Signal = Signal_1.defineSignal(ObservableObject.PropertyChangeSignal, { target: obj }))); }
	        });
	    }
	}
	/** Helper function to get a prototype's property descriptor */
	function _getProtoPropDesc(obj, member) {
	    var proto = Object.getPrototypeOf(obj);
	    return proto ?
	        Object.getOwnPropertyDescriptor(proto, String(member)) ||
	            _getProtoPropDesc(proto, member) :
	        null;
	}
	/** Helper function to add a getter and setter for a single property value */
	function _defineObservableProperty(obj, member, initial, getter, setter, getFilter, setFilter) {
	    var hiddenMember = _getHiddenName(member);
	    // clear existing observable value, if any
	    if (Object.prototype.hasOwnProperty.call(obj, hiddenMember))
	        ObservableObject.deleteObservableProperty(obj, member);
	    else {
	        Object.defineProperty(obj, hiddenMember, {
	            configurable: true,
	            enumerable: false,
	            value: false
	        });
	    }
	    // helper function that returns ObservableValue for "this".member
	    var getObservableValue = (function () {
	        var _this = this;
	        if (this[hiddenMember])
	            return this[hiddenMember];
	        var instance;
	        if (initial instanceof Observable_1.ObservableValue) {
	            // use reference directly
	            instance = initial;
	        }
	        else {
	            // create new observable value
	            Observable_1.unobserved(function () {
	                instance = Observable_1.ObservableValue.fromValue(initial === undefined ?
	                    undefined : setFilter ? setFilter(initial) : initial);
	                if (getter)
	                    instance.getter(getter.bind(_this));
	                if (setter)
	                    instance.setter(setter.bind(_this));
	            });
	        }
	        Object.defineProperty(this, hiddenMember, {
	            value: instance,
	            writable: false,
	            enumerable: false,
	            configurable: true
	        });
	        // emit PropertyChange for Observable object properties
	        if (typeof this.PropertyChange === "function")
	            instance.emitOnChange(this.PropertyChange, member);
	        return instance;
	    }).bind(obj);
	    // apply filter(s) if any
	    var getValue = getFilter ? function () { return getFilter(getObservableValue().value); } :
	        function () { return getObservableValue().value; };
	    var setValue = setFilter ? function (v) { getObservableValue().value = setFilter(v); } :
	        function (v) { getObservableValue().value = v; };
	    // apply getter and setter
	    Object.defineProperty(obj, member, {
	        get: getValue,
	        set: setValue,
	        enumerable: true,
	        configurable: true
	    });
	}
	function _getHiddenName(name) {
	    return "*observable:" + name;
	}
	// =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
	/** *Property/accessor decorator*, makes a property observable on every instance [requires ES5+ target] [decorator] */
	function observable(target, key, descriptor) {
	    if (!descriptor)
	        descriptor = { enumerable: true };
	    var getter = descriptor.get, setter = descriptor.set;
	    var initial = getter ? undefined : target[key];
	    descriptor.set = function (value) {
	        if (getter || setter) {
	            // define observable property with getter and/or setter
	            _defineObservableProperty(this, key, undefined, getter, setter, descriptor.get["*observable-getfilter"], descriptor.get["*observable-setfilter"]);
	            this[key] = value;
	        }
	        else {
	            // define observable property with initial value
	            _defineObservableProperty(this, key, value, undefined, undefined, descriptor.get["*observable-getfilter"], descriptor.get["*observable-setfilter"]);
	        }
	    };
	    descriptor.get = function () {
	        // if setter not run fist:
	        // make property actually observable and get its value
	        _defineObservableProperty(this, key, initial, getter, setter, descriptor.get["*observable-getfilter"], descriptor.get["*observable-setfilter"]);
	        return this[key];
	    };
	    descriptor.get["*observable-getter"] = true;
	    return descriptor;
	}
	exports.observable = observable;
	/** *Property/accessor decorator*, makes a property observable on every instance and converts values to strings when read (empty string for null/undefined/NaN) [requires ES5+ target] [decorator] */
	function observable_string(target, key, descriptor) {
	    descriptor = observable(target, key, descriptor);
	    descriptor.get["*observable-getfilter"] = function (value) {
	        return (value || value === 0 || value === false) ? String(value) : "";
	    };
	    return descriptor;
	}
	exports.observable_string = observable_string;
	/** *Property/accessor decorator*, makes a property observable on every instance and converts values to numbers using Number(...) when read [requires ES5+ target] [decorator] */
	function observable_number(target, key, descriptor) {
	    descriptor = observable(target, key, descriptor);
	    descriptor.get["*observable-getfilter"] = function (value) { return Number(value); };
	    return descriptor;
	}
	exports.observable_number = observable_number;
	/** *Property/accessor decorator*, makes a property observable on every instance and enforces that values are not undefined or null when read (throws TypeError) and that undefined/null values cannot be set (also throws TypeError) [requires ES5+ target] [decorator] */
	function observable_nonNull(target, key, descriptor) {
	    descriptor = observable(target, key, descriptor);
	    descriptor.get["*observable-getfilter"] = function (value) {
	        if (value === undefined || value === null)
	            throw new TypeError(key + " is " + value);
	        return value;
	    };
	    descriptor.get["*observable-setfilter"] = function (value) {
	        if (value === undefined || value === null)
	            throw new TypeError(key + " cannot be " + value);
	        return value;
	    };
	    return descriptor;
	}
	exports.observable_nonNull = observable_nonNull;
	/** *Property/accessor decorator*, makes a property observable on every instance and enforces that values are not undefined or null when read (throws TypeError) and that only instances of Object can be set, which are sealed automatically [requires ES5+ target] [decorator] */
	function observable_seal(target, key, descriptor) {
	    descriptor = observable(target, key, descriptor);
	    descriptor.get["*observable-getfilter"] = function (value) {
	        if (value === undefined || value === null)
	            throw new TypeError(key + " is " + value);
	        return value;
	    };
	    descriptor.get["*observable-setfilter"] = function (value) {
	        if (!(value instanceof Object))
	            throw new Error(value + " is not an instance of Object");
	        return Object.isSealed(value) ? value : Object.seal(value);
	    };
	    return descriptor;
	}
	exports.observable_seal = observable_seal;
	/** *Property/accessor decorator*, makes a property observable on every instance and enforces that values are not undefined or null when read (throws TypeError) and that only instances of Object can be set, which are frozen automatically [requires ES5+ target] [decorator] */
	function observable_freeze(target, key, descriptor) {
	    descriptor = observable(target, key, descriptor);
	    descriptor.get["*observable-getfilter"] = function (value) {
	        if (value === undefined || value === null)
	            throw new TypeError(key + " is " + value);
	        return value;
	    };
	    descriptor.get["*observable-setfilter"] = function (value) {
	        if (!(value instanceof Object))
	            throw new Error(value + " is not an instance of Object");
	        return Object.isFrozen(value) ? value : Object.freeze(value);
	    };
	    return descriptor;
	}
	exports.observable_freeze = observable_freeze;


/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var Observable_1 = __webpack_require__(5);
	var ObservableObject_1 = __webpack_require__(6);
	;
	/** Encapsulates Array with observable properties; the result works exactly like a regular array, but setting elements outside the bounds of the array (>length) does NOT work: length must be set first */
	var ObservableArray = (function () {
	    /** Create a new empty ObservableArray instance */
	    function ObservableArray() {
	        var _this = this;
	        Observable_1.assertUnobserved();
	        var _length = Observable_1.ObservableValue.fromValue(0);
	        Object.defineProperty(this, "length", {
	            get: function () { return _length.value; },
	            set: function (value) {
	                // make new numeric properties observable
	                var currentLength = _length.getLastValue() || 0;
	                while (currentLength < value)
	                    ObservableObject_1.ObservableObject.makeObservable(_this, currentLength++);
	                // clear removed properties
	                for (var l = value; l < currentLength; l++)
	                    ObservableObject_1.ObservableObject.deleteObservableProperty(_this, l);
	                _length.value = value;
	            },
	            configurable: true
	        });
	    }
	    /** Create an ObservableArray out of a regular Array */
	    ObservableArray.fromArray = function (array) {
	        var result = new ObservableArray();
	        for (var i = array.length - 1; i >= 0; i--)
	            result[i] = array[i];
	        result.length = array.length;
	        return result;
	    };
	    /** Create an ObservableArray that takes array elements from the array in given ObservableValue, or the value itself as a single element if it is not an array, or an empty array if the value is null or undefined; changes in array elements and/or observable value are reflected asynchronously */
	    ObservableArray.fromObservableValue = function (observableValue) {
	        var result = new ObservableArray();
	        // proxy length and all numeric properties in result
	        var _length = 0;
	        var makeMap = function (i) { return new Observable_1.ObservableValue(function () {
	            var value = observableValue.value;
	            if (value instanceof Array)
	                return value[i];
	            else if (i === 0 && value !== null)
	                return value;
	            else
	                return undefined;
	        }); };
	        Object.defineProperty(result, "length", {
	            get: function () {
	                var value = observableValue.value;
	                var newLength = (value instanceof Array) ? value.length :
	                    (value === undefined || value === null) ? 0 : 1;
	                if (newLength > _length) {
	                    Observable_1.unobserved(function () {
	                        // make new numeric properties observable
	                        var spec = {};
	                        for (var l = _length; l < newLength; l++)
	                            spec[l] = makeMap(l);
	                        ObservableObject_1.ObservableObject.makeObservable(result, spec);
	                    });
	                }
	                else {
	                    Observable_1.unobserved(function () {
	                        // clear removed properties
	                        for (var l = newLength; l < _length; l++)
	                            ObservableObject_1.ObservableObject.deleteObservableProperty(result, l);
	                    });
	                }
	                return _length = newLength;
	            },
	            set: function () {
	                throw new Error("Cannot modify length of mapped array");
	            }
	        });
	        // initialize all values
	        Observable_1.unobserved(function () { return result.length; });
	        return result;
	    };
	    /** Create a read-only ObservableArray with each value of the original array mapped to the result of the given getter function; observable values used in the map function are not observed (like ObservableValue map method); the getter is called for combinations of value and index (i.e. deleting a value in the middle of the source array will trigger changes for all elements after it; if the index is not important then use mapAsyncValues instead); the resulting array length changes along with the original array length */
	    ObservableArray.prototype.mapAsync = function (callback, thisArg) {
	        var _this = this;
	        var result = new ObservableArray();
	        // keep length in an observable together just like the properties to avoid
	        // unexpected differences in change propagation timings
	        var observableLength = new Observable_1.ObservableValue(function () { return _this.length; });
	        // proxy all numeric properties in result
	        var _length = 0;
	        var makeMap = function (i) {
	            var lastValue = {};
	            var mapped = new Observable_1.ObservableValue(function () {
	                var value = _this[i];
	                if (value === lastValue)
	                    return mapped.value;
	                return Observable_1.unobserved(function (value) {
	                    return (i >= 0 && i < _this.length) ?
	                        callback.call(thisArg || result, value, i, _this) :
	                        undefined;
	                }, lastValue = value);
	            });
	            return mapped;
	        };
	        Object.defineProperty(result, "length", {
	            get: function () {
	                var newLength = observableLength.value;
	                if (newLength > _length) {
	                    Observable_1.unobserved(function () {
	                        // make new numeric properties observable
	                        var spec = {};
	                        for (var l = _length; l < newLength; l++)
	                            spec[l] = makeMap(l);
	                        ObservableObject_1.ObservableObject.makeObservable(result, spec);
	                    });
	                }
	                else if (newLength < _length) {
	                    Observable_1.unobserved(function () {
	                        // clear removed properties
	                        for (var l = newLength; l < _length; l++)
	                            ObservableObject_1.ObservableObject.deleteObservableProperty(result, l);
	                    });
	                }
	                return _length = newLength;
	            },
	            set: function () {
	                throw new Error("Cannot modify length of mapped array");
	            }
	        });
	        // initialize all values
	        Observable_1.unobserved(function () { return result.length; });
	        return result;
	    };
	    /** Create a read-only ObservableArray with each value of the original array mapped to the result of the given function; observable values used in the map function are not observed (like ObservableValue map method); the resulting array length changes along with the original array length; this method is slightly more expensive than mapAsync for larger arrays, especially in non-ES6 environments, but is overall more efficient because it avoids unnecessary callbacks when subscribed to */
	    ObservableArray.prototype.mapAsyncValues = function (callbackfn) {
	        var _this = this;
	        // keep track of previously seen values in a Map (with "semi-polyfill")
	        var _get, _add;
	        var _del;
	        var _forEach;
	        if (typeof Map === "function") {
	            // use native Map implementation
	            var map = new Map();
	            _get = map.get.bind(map), _add = map.set.bind(map);
	            _forEach = map.forEach.bind(map);
	            _del = map.delete.bind(map);
	        }
	        else {
	            // use minimal approximation of Map methods
	            var ownMap = [];
	            _add = function (v, o) { ownMap.push({ v: v, o: o }); };
	            _get = function (v) {
	                var result;
	                ownMap.some(function (x) { return (x.v === v ? (result = x.o, true) : false); });
	                return result;
	            };
	            _del = function (v) {
	                ownMap.some(function (x, i) { return (x.v === v ? !!ownMap.splice(i, 1) : false); });
	            };
	            _forEach = function (f) {
	                ownMap.slice(0).forEach(function (x) { return f(x.o, x.v); });
	            };
	        }
	        // keep track of all current inputs to be able to prune the map
	        // (really only works when entire array is subscribed to)
	        var currentInputs = [];
	        var timer = -1;
	        var deferPrune = function () {
	            if (timer >= 0)
	                clearTimeout(timer);
	            var myTimer = timer = setTimeout(function () {
	                if (myTimer === timer) {
	                    timer = -1;
	                    var len = _this.length;
	                    if (currentInputs.length > len)
	                        currentInputs.length = len;
	                    _forEach(function (o, v) {
	                        currentInputs.indexOf(v) < 0 && _del(v);
	                    });
	                }
	            }, 1);
	        };
	        // prune the map when the array gets shorter
	        new Observable_1.ObservableValue(function () { return _this.length; }).subscribe(function (len) {
	            if (currentInputs.length > len)
	                deferPrune();
	        });
	        // map input array to another observable array
	        var ownNaN = {}, ownUndefined = {};
	        return this.mapAsync(function (v, i) {
	            var defv = v === undefined ? ownUndefined :
	                (typeof v === "number" && isNaN(v)) ? ownNaN : v;
	            if (currentInputs[i] !== undefined && currentInputs[i] !== defv)
	                deferPrune();
	            currentInputs[i] = defv;
	            // return last result for same input value if found
	            var found = _get(defv);
	            if (found !== undefined)
	                return found;
	            // get result for current input value and keep it for later
	            var o = callbackfn(v);
	            _add(defv, o);
	            return o;
	        });
	    };
	    /** Represent observable arrays as regular JSON arrays */
	    ObservableArray.prototype.toJSON = function () {
	        return this.slice(0);
	    };
	    return ObservableArray;
	}());
	exports.ObservableArray = ObservableArray;
	var _mapAsync = ObservableArray.prototype.mapAsync;
	var _mapAsyncValues = ObservableArray.prototype.mapAsyncValues;
	var _toJSON = ObservableArray.prototype.toJSON;
	ObservableArray.prototype = new Array;
	ObservableArray.prototype.constructor = ObservableArray;
	ObservableArray.prototype.mapAsync = _mapAsync;
	ObservableArray.prototype.mapAsyncValues = _mapAsyncValues;
	ObservableArray.prototype.toJSON = _toJSON;
	// these functions should not depend on .length but would if not wrapped
	var _arrayPush = ObservableArray.prototype.push;
	ObservableArray.prototype.push = function () {
	    var _this = this;
	    var items = [];
	    for (var _i = 0; _i < arguments.length; _i++) {
	        items[_i] = arguments[_i];
	    }
	    return Observable_1.unobserved(function () { return _arrayPush.apply(_this, items); });
	};
	var _arrayUnshift = ObservableArray.prototype.unshift;
	ObservableArray.prototype.unshift = function () {
	    var _this = this;
	    var items = [];
	    for (var _i = 0; _i < arguments.length; _i++) {
	        items[_i] = arguments[_i];
	    }
	    return Observable_1.unobserved(function () { return _arrayUnshift.apply(_this, items); });
	};
	// override concat, which otherwise would see ObservableArrays as values:
	ObservableArray.prototype.concat = function () {
	    var items = [];
	    for (var _i = 0; _i < arguments.length; _i++) {
	        items[_i] = arguments[_i];
	    }
	    return Array.prototype.concat.apply(this.slice(0), items.map(function (item) { return (item instanceof ObservableArray) ? item.slice(0) : item; }));
	};
	/** Returns an ObservableArray instance based on the result of given function: if the returned value is an array, then all elements are copied to the result; if the returned value is an observable array, all elements are proxied; if the returned value is not an array, the result contains this value as a single element; if the returned value is null or undefined, the result will be an empty array; changes in values/elements are reflected asynchronously */
	function observeArray(f) {
	    return ObservableArray.fromObservableValue(new Observable_1.ObservableValue(f));
	}
	exports.observeArray = observeArray;


/***/ },
/* 8 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var Promise_1 = __webpack_require__(4);
	/** Helper function for sending a simple JSON request, returns a promise for the XHR responseText */
	function _xhr(method, url, data, headers) {
	    return new Promise_1.Promise(function (resolve, reject) {
	        try {
	            // create request and send data
	            var xhr = new XMLHttpRequest();
	            xhr.open(method, url, true);
	            if (headers) {
	                for (var key in headers) {
	                    if (Object.prototype.hasOwnProperty.call(headers, key))
	                        xhr.setRequestHeader(key, headers[key]);
	                }
	            }
	            if (data !== undefined) {
	                xhr.setRequestHeader("Content-Type", "application/json");
	                xhr.send(JSON.stringify(data));
	            }
	            else
	                xhr.send();
	            // await response and resolve or reject promise
	            xhr.onreadystatechange = function () {
	                try {
	                    if (xhr.readyState == 4) {
	                        if (xhr.status >= 200 && xhr.status < 400)
	                            resolve(xhr.responseText);
	                        else
	                            reject(new Error("HTTP " + xhr.status +
	                                (xhr.responseText ? ": " + xhr.responseText : "")));
	                    }
	                }
	                catch (all) {
	                    reject(all);
	                }
	            };
	        }
	        catch (all) {
	            reject(all);
	        }
	    });
	}
	/** Helper function to add an "Accept: application/json" header */
	function _withAccept(headers, accept) {
	    if (headers === void 0) { headers = {}; }
	    if (accept === void 0) { accept = "application/json"; }
	    if (!headers["Accept"])
	        headers["Accept"] = accept;
	    return headers;
	}
	/** A static class that wraps simple request methods to send and receive data asynchronously */
	var Http = (function () {
	    function Http() {
	    }
	    /** Perform a GET request with given parameters and headers, if any; returns a promise that resolves to the response text */
	    Http.getText = function (url, params, headers) {
	        if (params) {
	            var first = (url.indexOf("?") < 0);
	            for (var key in params) {
	                if (Object.prototype.hasOwnProperty.call(params, key)) {
	                    url += (first ? "?" : "&") + encodeURIComponent(key)
	                        + "=" + encodeURIComponent(params[key]);
	                    first = false;
	                }
	            }
	        }
	        return _xhr("GET", url, undefined, headers);
	    };
	    /** Perform a GET request with given parameters and headers, if any; returns a promise that resolves to the parsed JSON response */
	    Http.get = function (url, params, headers) {
	        return Http.getText(url, params, _withAccept(headers))
	            .then(function (responseText) { return JSON.parse(responseText); });
	    };
	    /** Perform a POST request with given object (sent as JSON) and headers, if any; returns a promise that resolves to the parsed JSON response */
	    Http.post = function (url, data, headers) {
	        return _xhr("POST", url, data, _withAccept(headers))
	            .then(function (responseText) { return JSON.parse(responseText); });
	    };
	    /** Perform a PUT request with given object (sent as JSON) and headers, if any; returns a promise that resolves to the parsed JSON response */
	    Http.put = function (url, data, headers) {
	        return _xhr("PUT", url, data, _withAccept(headers))
	            .then(function (responseText) { return JSON.parse(responseText); });
	    };
	    /** Perform a DELETE request with given object (sent as JSON) and headers, if any; returns a promise that resolves to the parsed JSON response */
	    Http.delete = function (url, data, headers) {
	        return _xhr("DELETE", url, data, _withAccept(headers))
	            .then(function (responseText) { return JSON.parse(responseText); });
	    };
	    /** Perform a GET request with given parameters and headers, if any; returns a promise that resolves to the parsed HTML result body as a document fragment (ignores everything before and after body tag, if any; inserts everything if no body tag is found, i.e. partial HTML) */
	    Http.getHtmlContent = function (url, params, headers) {
	        return Http.getText(url, params, _withAccept(headers, "text/html"))
	            .then(function (responseText) {
	            // find body tag and keep only its content
	            responseText = String(responseText || "");
	            var startTag = responseText.match(/<body(?:>|\s[^>]+>)/m);
	            if (startTag) {
	                responseText = responseText.slice(startTag.index + startTag[0].length);
	                var endTagPos = responseText.lastIndexOf("</body>");
	                if (endTagPos >= 0)
	                    responseText = responseText.slice(0, endTagPos);
	            }
	            // set inner HTML of a placeholder element
	            var placeholder = document.createElement("div");
	            placeholder.innerHTML = responseText;
	            // transfer resulting elements to document fragment
	            var result = document.createDocumentFragment();
	            while (placeholder.firstChild)
	                result.appendChild(placeholder.firstChild);
	            return result;
	        });
	    };
	    return Http;
	}());
	exports.Http = Http;


/***/ }
/******/ ]);